/* ***********************************************************************************
 *                                                                                   *
 * Copyright (c) 1997, 1998                                                          *
 * Araneus Group and Department of "Informatica ed Automazione"                      *
 * of Universita' "Roma Tre", Rome, ITALY.                                           *
 *                                                                                   *
 * All Rights Reserved.                                                              *
 *                                                                                   *
 * Permission to use, copy, and distribute this software and its documentation for   *
 * NON-COMMERCIAL purposes and without fee is hereby granted provided  that this     *
 * copyright notice appears in all copies.                                           *
 *                                                                                   *
 * THE AUTHORS MAKE NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE    *
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED     *
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR               *
 * NON-INFRINGEMENT. THE AUTHOR SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY      *
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR  ITS    *
 * DERIVATIVES.                                                                      *
 *                                                                                   *
 *********************************************************************************** */


package shell;

import java.io.*;
import java.util.*;
import telemaco.*;
import penelope.*;
import document.*;

/*
 *    class CommandShell extends Object
 *
 *    "command shell for Araneus WSDS"
 * 
 *    (v. 3.0) A. Masci, G. Mecca
 *
 *    -- methods
 *   
 */

class CommandShell extends Object
 {

  public static void main(String args[]) 
    {
       //variabili 
       String plFile = "";
       String siteDir = "";
       String format = "";
       String style = "";

       Document editorCFG=null;
        
       /*inizializzo ConfigShell*/
       String userDir = System.getProperty("user.dir");
       StringTokenizer tokenCP = new StringTokenizer(userDir,";");
       File fileConfig = new File("");
       while(tokenCP.hasMoreTokens())
       {
         fileConfig = new File(tokenCP.nextToken(), "shell"+File.separator+"config");
         if(fileConfig.exists())
          break;
       }
       File ConfigShell = new File(fileConfig.getAbsolutePath(),"CommandShell.cfg");
       try
       {
         editorCFG = new Document(ConfigShell.getAbsolutePath());
       }catch(DocumentException de){System.out.println(""+de);}

       //inizializzo il pl
       editorCFG.search("SiteDir");
       editorCFG.search(":");
       editorCFG.setStartPoint(editorCFG.getPosition());
       editorCFG.search("*;");
       editorCFG.copy();      
       siteDir = editorCFG.clipboardToString();
       siteDir = siteDir.substring(0,siteDir.length()-1);
       editorCFG.search("PLFile");
       editorCFG.search(":");
       editorCFG.setStartPoint(editorCFG.getPosition());
       editorCFG.search("*;");
       editorCFG.copy();      
       plFile = editorCFG.clipboardToString();
       plFile = plFile.substring(0,plFile.length()-1);
       editorCFG.search("Format");
       editorCFG.search(":");
       editorCFG.setStartPoint(editorCFG.getPosition());
       editorCFG.search("*;");
       editorCFG.copy();      
       format = editorCFG.clipboardToString();
       format = format.substring(0,format.length()-1);
       editorCFG.search("Stylesheet");
       editorCFG.search(":");
       editorCFG.setStartPoint(editorCFG.getPosition());
       editorCFG.search("*;");
       editorCFG.copy();      
       style = editorCFG.clipboardToString();
       style = style.substring(0,style.length()-1);
       editorCFG.reset();

       if( args.length==0)
       {
         welcomeMessage();
         
         if (plFile=="")
           System.out.println("No PL File Selected");
         else
          System.out.println("Selected Site: "+plFile);
         System.out.println("Please type a command; type 'Shell help' for help");
         System.out.println();
         return;
       }

       if( args[0].equalsIgnoreCase("HELP") )
       {
         welcomeMessage();
         
         System.out.println();
         System.out.println("Araneus CommandShell Commands:"+'\n'+
             "-----------------------------------------------------------------------------"+'\n'+
             "Shell SELECT <PLFile>          : selects a PL file"+'\n'+
             "Shell SHOW                     : shows selected PL file"+'\n'+
             "Shell FORMAT HTML              : selects html as a format for the site "+'\n'+
             "Shell FORMAT XML               : selects xml as a format for the site"+'\n'+             
             '\n'+  
             "Shell TPL [<p1>...<pn>]        : generates tpl [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell STY [<p1> ... <pn>]      : generates styles [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell TPL+STY [<p1>...<pn>]    : generates tpl+styles [for page-schemes <p1>...<pn>]"+'\n'+
             '\n'+  
             "Shell GENERATE [<p1> ... <pn>] : generates pages [for page-schemes <p1>...<pn>]"+'\n'+
             '\n'+  
             "Shell HELP                     : shows this help screen"+'\n'+
             "Shell QUIT                     : exits Araneus TextShell");
         System.out.println();
         return;
       }

       if( args[0].equalsIgnoreCase("HELPE") )
       {
         //welcomeMessage();
         
         System.out.println();
         System.out.println("Araneus CommandShell Commands:"+'\n'+
             "-----------------------------------------------------------------------------"+'\n'+
             "Shell SELECT <PLFile>          : selects a PL file"+'\n'+
             "Shell SHOW                     : shows selected PL file"+'\n'+
             "Shell FORMAT HTML              : selects html as a format for the site "+'\n'+
             "Shell FORMAT XML               : selects xml as a format for the site"+'\n'+             
             "Shell STYLESHEET XSL           : selects xsl as a style format for the site (for xml only)"+'\n'+
             "Shell STYLESHEET DSSSL         : selects dsssl as a style format for the site (for xml only)"+'\n'+
             '\n'+ 
             "Shell TPL [<p1>...<pn>]        : generates tpl [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell STY [<p1> ... <pn>]      : generates styles [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell TPL+STY [<p1>...<pn>]    : generates tpl+styles [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell XSL [<p1>...<pn>]        : generates xsl stylesheets [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell ALIGNTPL [<p1>...<pn>]   : aligns tpl with styles [for page-schemes <p1>...<pn>]"+'\n'+
             '\n'+
             "Shell GENERATE [<p1> ... <pn>] : generates pages [for page-schemes <p1>...<pn>]"+'\n'+
             "Shell HIDE                     : prevents directory listing in the target site"+'\n'+
             "Shell DDL                      : generates ddl for the target site"+'\n'+
             "Shell EXEC <trans> [<param>]   : executes transaction <trans> [with parameters]"+'\n'+
             '\n'+
             "Shell HELP                     : shows this help screen"+'\n'+
             "Shell QUIT                     : exits Araneus TextShell");
         System.out.println();
         return;
       }

       /* *****General commands***** */

       if( args[0].equalsIgnoreCase("SELECT") )
       {
         welcomeMessage();

         if(args.length==2)
         {
           String pathPL = args[1];
           File filePL = new File(pathPL);
           pathPL = filePL.getAbsolutePath().toString();
           //controllo se pathPL termina con l'estensione .PL
           if(!(pathPL.substring(pathPL.length()-3,pathPL.length())).equalsIgnoreCase(Telemaco.extensionPL))
             pathPL = pathPL+Telemaco.extensionPL;
             
           File PL = new File(pathPL);
           if(!PL.exists())
           {
             System.out.println("File "+pathPL+" not found");
             return;
           }
           try
           {
             File completeFilePL = new File(pathPL);
             String path = completeFilePL.getParent();
             //System.out.println(path);
             editorCFG.replace("SiteDir*:*;", "SiteDir :"+path+File.separator+";");
             editorCFG.replace("PLFile*:*;", "PLFile :"+pathPL+";");
             editorCFG.save();
           }catch(DocumentException d){System.out.println(""+d);}
           System.out.println("PL File Selected.");
         }
         else
            System.out.println("Expecting: Select <filename>");
        
         System.out.println();
         return;
        }


       if( args[0].equalsIgnoreCase("SHOW") )
       {
         System.out.println();
         if (plFile=="")
          System.out.println("No PL File Selected");
         else
          {
            System.out.println("Selected Site Directory: "+siteDir);
            System.out.println("Selected Site PL File:   "+plFile);
            System.out.println("Selected Format:         "+format);
            System.out.println("Selected Stylesheets:    "+style);
          }
         System.out.println();
         return;
       }


       if( args[0].equalsIgnoreCase("FORMAT") )
       {
         if(args.length==2)
         {
           if (args[1].equalsIgnoreCase("HTML") || args[1].equalsIgnoreCase("XML")) 
           {
             format = args[1];
             try
             {
               editorCFG.replace("Format*:*;", "Format :"+format+";");
               if (format.equalsIgnoreCase("HTML"))
                 style="html";
               if (format.equalsIgnoreCase("XML"))
                 style="xsl";  
               editorCFG.replace("Stylesheet*:*;", "Stylesheet :"+style+";");
               editorCFG.save();
             }catch(DocumentException d){System.out.println(""+d);}
             System.out.println("Format Selected.");
           }
           else
              System.out.println("Expecting: Format <html | xml>");
         }
         else
           System.out.println("Expecting: Format <html | xml>");
        
         System.out.println();
         return;
        }


       if( args[0].equalsIgnoreCase("STYLESHEET") )
       {
         if(args.length==2)
         {
           if (format.equalsIgnoreCase("XML") && 
               (args[1].equalsIgnoreCase("XSL") || args[1].equalsIgnoreCase("DSSSL")))  
           {
             style = args[1];
             try
             {
               editorCFG.replace("Stylesheet*:*;", "Stylesheet :"+style+";");
               editorCFG.save();
             }catch(DocumentException d){System.out.println(""+d);}
             System.out.println("Stylesheet Selected.");
           }
           else
              System.out.println("Expecting: Stylesheet <xsl | dsssl | css> (for xml only)");
         }
         else
           System.out.println("Expecting: Stylesheet <xsl | dsssl | css> (for xml only)");
        
         System.out.println();
         return;
        }

       /* *****Telemaco commands***** */

       if( args[0].equalsIgnoreCase("TPL") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              Telemaco telem = new Telemaco (plFile);
              telem.setMessage(2);
              if(args.length>1)
              {
                for (int i=1;i<args.length;i++)
                  telem.constructTemplate(args[i]);
              }
              else
                telem.constructTemplates();
            }catch(TelemacoException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }
        
       if( args[0].equalsIgnoreCase("STY") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              Telemaco telem = new Telemaco (plFile);
              telem.setMessage(2);
              telem.setStyle(style);
              if(args.length>1)
              {
                for (int i=1;i<args.length;i++)
                  telem.constructATS(args[0],args[i],true);
              }
              else
                telem.constructAllATS(true);
            }catch(TelemacoException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }
        
       if( args[0].equalsIgnoreCase("XSL") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              Telemaco telem = new Telemaco (plFile);
              telem.setMessage(2);
              telem.setStyle(style);
              if(args.length>1)
              {
                String pages[]= new String[args.length];
                for (int i=0;i<args.length;i++)
                  pages[i]=new String(args[i]);
                telem.constructXSL(pages, plFile); 
              }
              else
                telem.constructAllXSL(plFile);
            }catch(TelemacoException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }

       if( args[0].equalsIgnoreCase("TPL+STY") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
               Telemaco telem = new Telemaco (plFile);
              telem.setMessage(2);
              telem.setStyle(style);
              if(args.length>1)
              {
                for (int i=1;i<args.length;i++)
                {
                  telem.constructTemplate(args[i]);
                  telem.constructATS(args[0],args[i],true);
                }
              }
              else
              { 
                telem.constructTemplates();
                telem.constructAllATS(true);
              }
            }catch(TelemacoException pe){System.out.println(""+pe);}
          }
          
          System.out.println();          
          return;
        }
        
       if( args[0].equalsIgnoreCase("alignTPL") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              Telemaco telem = new Telemaco (plFile);
              telem.setMessage(2);
              if(args.length>1)
              {
                for (int i=1;i<args.length;i++)
                  telem.ReConstructTemplate(args[i]);
              }
              else
                  telem.ReConstructTemplates();
            }catch(TelemacoException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }

       /* *****Penelope commands***** */

       if( args[0].equalsIgnoreCase("GENERATE") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              PenelopePDL penny =  new PenelopePDL(plFile.substring(0,plFile.length()-3));
              penny.setMessage(penny.text);
              penny.setMetaTag(penny.off);
              if(format.equalsIgnoreCase("XML"))
              {
                penny.setXML(penny.on);
                penny.setMetaTag(penny.on);
              }
              penny.parse();
              if (args.length>1)
              {
                 for (int j=1;j<args.length;j++)
                 {
                    penny.check(args[j]); 
                    penny.generateML(args[j]);
                 }
              } 
              else
                penny.generateML();
              penny.close();
            }catch(PenelopeException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }
        
       if( args[0].equalsIgnoreCase("HIDE") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              PenelopePDL penny =  new PenelopePDL(plFile.substring(0,plFile.length()-3));
              penny.setMessage(penny.text);
              penny.parse();
              penny.hideDirectory("index.html");
              penny.close();
            }catch(PenelopeException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }

       if( args[0].equalsIgnoreCase("DDL") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            try
            {
              PenelopePDL penny =  new PenelopePDL(plFile.substring(0,plFile.length()-3));
              penny.setMessage(penny.text);
              penny.parse();
              penny.generateDDL();
              penny.close();
            }catch(PenelopeException pe){System.out.println(""+pe);}
          }

          System.out.println();
          return;
        }

       if( args[0].equalsIgnoreCase("EXEC") )
       {
          if(plFile.equalsIgnoreCase(""))
             System.out.println("Please select a PL File first");
          else
          {
            //System.out.println("Pl File: "+plFile);
            String transaction=siteDir+"pml"+File.separator+args[1];
            
            if (args.length>2)               
            try  
             {  // Replace Parameters in the Transaction
                Document trans = new Document(transaction);

                for(int i=2; i<args.length; i++)
                {
                  trans.reset();
                  trans.replaceAll("%"+(i-1), args[i]);
                }
                trans.reset();
                trans.replaceAll("+"," ");
                
                trans.saveAs(transaction+".PML");
             
             } catch(DocumentException pe){ System.out.println(""+pe);}

            try
              {
                PenelopePML penny = new PenelopePML(transaction);
                PenelopePML.setMessage(PenelopePML.text);
                if(format.equalsIgnoreCase("XML"))
                  penny.setXML(penny.on);              
                penny.parse();
                penny.executeAll();
                penny.close();
              }catch(PenelopeException pe){System.out.println(""+pe); }

          }

          System.out.println();
          return;
        }


        System.out.println("Unrecognized command; type 'Shell help' for help.");
        System.out.println();

    }//end main

    public static void welcomeMessage()
    {
      System.out.println();
      System.out.println();
      System.out.println("     *************************************************************");
      System.out.println("     *                                                           *");
      System.out.println("     *  Copyright (c) 1997, 1998, 1999                           *");
      System.out.println("     *  Araneus Group and University 'Roma Tre', Rome, ITALY.    *");
      System.out.println("     *                                                           *");
      System.out.println("     *  All Rights Reserved.                                     *");
      System.out.println("     *                                                           *");
      System.out.println("     *  Permission to use, copy, and distribute this software    *");
      System.out.println("     *  and its documentation for NON-COMMERCIAL purposes and    *");
      System.out.println("     *  without fee is hereby granted provided  that this        *");
      System.out.println("     *  copyright notice appears in all copies.                  *");
      System.out.println("     *                                                           *");
      System.out.println("     *************************************************************");
      System.out.println();
      System.out.println("     Araneus WSDS; Type 'shell help' for a list of commands");
      System.out.println();
      System.out.println();      
    }

 } //end class
