SCHEME file:/c:sites\dept1\
ON Department

$ -------------------------------------------------------------------------------------------
$  HOME
$ -------------------------------------------------------------------------------------------

DEFINE PAGE HomePage : "Computer Science Department"
STYLE  sites\styles\pop.STY(100,375,difalato.jpg,Home Page)
$STYLE  sites\styles\popXML.STY(100,375,difalato.jpg,Home Page)
AS URL("index.html");
   ToResearchGroups : LINK-TO ResearchGroupListPage(
                                 URL ("index.html");
                                 GroupsLabel : TEXT = "Research Groups";
                              );
   ToPeople : LINK-TO PeopleListPage(
                                 URL ("index.html");
                                 PeopleLabel : TEXT = "People";
                              );
   ToCourses : LINK-TO EducationPage(
                                 URL ("index.html");
                                 CoursesLabel : TEXT = "Courses";
                              );
USING 
END


$ ---------------------------------------------------------------------------------------------
$  RESEARCH
$ ---------------------------------------------------------------------------------------------

DEFINE PAGE ResearchGroupListPage : "ResearchGroupListPage"
STYLE  sites\styles\pop.STY(142,211,eric.jpg,Research Groups)
$STYLE  sites\styles\popXML.STY(142,211,eric.jpg,Research Groups)
AS URL("index.html");
   GroupList : LIST-OF ( ToGroup : LINK-TO ResearchGroupPage(
                                                   URL (<GroupName>);
                                                   GroupName : TEXT = <GroupName>;
                                                );
                       );
USING ResearchGroup distinct
ORDER BY GroupName
END

DEFINE PAGE ResearchGroupPage : <GroupName>
STYLE  sites\styles\pop.STY(142,211,eric.jpg,Research Groups)
$STYLE  sites\styles\popXML.STY(142,211,eric.jpg,Research Groups)
AS URL(<GroupName>);
   Name : TEXT = <GroupName>;
   Topics : TEXT = <Topics>;
   MemberList : LIST-OF ( 
                         ToMember : LINK-TO PersonPage(
                                                        URL (<Name>);
                                                        Member : TEXT = <Name>;
                                                      );
                        );
USING ResearchGroup, PersonInGroup 
ORDER BY PersonInGroup.Name
END


$ ---------------------------------------------------------------------------------------------
$  EDUCATION
$ ---------------------------------------------------------------------------------------------

DEFINE PAGE EducationPage : "Education"
STYLE  sites\styles\pop.STY(100,375,difalato.jpg,Courses)
$STYLE  sites\styles\popXML.STY(100,375,difalato.jpg,Courses)
AS URL("index.html");
    CourseList : LIST-OF ( 
                            ToCourse : LINK-TO CoursePage(
                                             URL (<CourseName>);
                                             CourseName : TEXT = <CourseName>;
                                            );
                         );
USING Course
ORDER BY CourseName
END


DEFINE PAGE CoursePage : <CourseName>
STYLE  sites\styles\pop.STY(100,375,difalato.jpg,Courses)
$STYLE  sites\styles\popXML.STY(100,375,difalato.jpg,Courses)
AS URL(<CourseName>);
   Name : TEXT = <CourseName>;
   Description : TEXT = <Description>;
   ToInstructor :  LINK-TO PersonPage(
                                       URL (<Instructor>);
                                       InstructorName : TEXT = <Instructor>;
                                     );
USING Course
END 


$ ---------------------------------------------------------------------------------------------
$  PEOPLE
$ ---------------------------------------------------------------------------------------------

DEFINE PAGE PeopleListPage : "PeopleListPage"
STYLE  sites\styles\pop.STY(140,210,epeople.jpg,People)
$STYLE  sites\styles\popXML.STY(140,210,epeople.jpg,People)
AS URL("index.html");
   PeopleList : LIST-OF ( ToPerson : LINK-TO PersonPage(
                                                        URL (<Name>);
                                                        Name : TEXT = <Name>;
                                                       );
                         );
USING Person distinct
ORDER BY Name
END


DEFINE PAGE PersonPage : <Name>
STYLE  sites\styles\pop.STY(140,210,epeople.jpg,People)
$STYLE  sites\styles\popXML.STY(140,210,epeople.jpg,People)
AS URL(<Person.Name>);
   Name : TEXT = <Name>;
   Photo : IMAGE = <Photo>;
   Position : TEXT = <Position>;
   Email : TEXT = <email>;
   Phone : TEXT = <Phone>;
   GroupList : LIST-OF (ToGroup : LINK-TO ResearchGroupPage (
                                         URL(<PersonGroup.GroupName>);
                                         LabelGroup : TEXT = <GroupName>;
                                       );
                        );             
   CourseList : LIST-OF (ToCourse : LINK-TO CoursePage (
                                   URL(<CourseName>);
                                   LabelCourse : TEXT = <CourseName>;
                                 );
                        );
USING Person,
      PersonGroup : (SELECT Person.Name, PersonInGroup.GroupName
                     FROM Person, PersonInGroup
                     WHERE Person.Name = PersonInGroup.Name), 
      PersonCourses : ( SELECT Person.Name, Course.CourseName
                        FROM Person, Course
                        WHERE Course.Instructor = Person.Name )
END 

 
$ ---------------------------------------------------------------------------------------------


 





